/********************************** (C) COPYRIGHT *******************************
* File Name          : main.c
* Author             : WCH
* Version            : V1.0.0
* Date               : 2022/01/18
* Description        : Main program body.
* Copyright (c) 2021 Nanjing Qinheng Microelectronics Co., Ltd.
* SPDX-License-Identifier: Apache-2.0
*******************************************************************************/
#include "debug.h"
#include "string.h"
#include "easyflash.h"
#include <stdio.h>
#include <stdlib.h>



static void test_env(void) {
    uint32_t i_boot_times = 0;
    char *c_old_boot_times, c_new_boot_times[11] = {0};

    /* get the boot count number from Env */
    c_old_boot_times = ef_get_env("boot_times");
    i_boot_times = atol(c_old_boot_times);
    /* boot count +1 */
    i_boot_times ++;
    printf("The system now boot %d times\n\r", i_boot_times);
    /* interger to string */
    sprintf(c_new_boot_times,"%ld", i_boot_times);
    /* set and store the boot count number to Env */
    ef_set_env("boot_times", c_new_boot_times);
    ef_save_env();
}


/*********************************************************************
 * @fn      main
 *
 * @brief   Main program
 *
 * @return  none
 */
int main(void)
{
    NVIC_PriorityGroupConfig(NVIC_PriorityGroup_2);
    Delay_Init();
    USART_Printf_Init(115200);
    printf("SystemClk:%d\r\n", SystemCoreClock);

    char value[32] = {0};
    size_t len = 0;
    const char *v = "2";
    EfErrCode err = easyflash_init();
    if (err == EF_NO_ERR) {
        printf("=============\n");
        ef_print_env();
        printf("=============\n");
        len = ef_get_env_blob("boot_times", value, sizeof(value) , NULL);
        printf("boot_times:%s\tlen:%d\n",value,len);
        err = ef_set_env_blob("boot_times", v, strlen(value));
        printf("set err:%d\n",err);
    }
    while(1)
    {
    }
}

